#!/usr/bin/env node
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.__RewireAPI__ = exports.__ResetDependency__ = exports.__set__ = exports.__Rewire__ = exports.__GetDependency__ = exports.__get__ = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _templateObject = _taggedTemplateLiteral(["\n      {\n        __schema {\n          mutationType {\n            name\n            description\n            fields {\n              name\n              description\n              type {\n                name\n                fields {\n                  name\n                  description\n                  type {\n                    name\n                  }\n                }\n                ofType {\n                  name\n                  fields {\n                    name\n                    description\n                    type {\n                      name\n                    }\n                  }\n                }\n              }\n              args {\n                name\n                description\n                type {\n                  name\n                }\n              }\n            }\n          }\n          queryType {\n            name\n            description\n            fields {\n              name\n              description\n              type {\n                name\n                fields {\n                  name\n                  description\n                  type {\n                    name\n                  }\n                }\n                ofType {\n                  name\n                  fields {\n                    name\n                    description\n                    type {\n                      name\n                    }\n                  }\n                }\n              }\n              args {\n                name\n                description\n                type {\n                  name\n                }\n              }\n            }\n          }\n        }\n      }\n    "], ["\n      {\n        __schema {\n          mutationType {\n            name\n            description\n            fields {\n              name\n              description\n              type {\n                name\n                fields {\n                  name\n                  description\n                  type {\n                    name\n                  }\n                }\n                ofType {\n                  name\n                  fields {\n                    name\n                    description\n                    type {\n                      name\n                    }\n                  }\n                }\n              }\n              args {\n                name\n                description\n                type {\n                  name\n                }\n              }\n            }\n          }\n          queryType {\n            name\n            description\n            fields {\n              name\n              description\n              type {\n                name\n                fields {\n                  name\n                  description\n                  type {\n                    name\n                  }\n                }\n                ofType {\n                  name\n                  fields {\n                    name\n                    description\n                    type {\n                      name\n                    }\n                  }\n                }\n              }\n              args {\n                name\n                description\n                type {\n                  name\n                }\n              }\n            }\n          }\n        }\n      }\n    "]);

require("babel-polyfill");

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _commander = require("commander");

var _commander2 = _interopRequireDefault(_commander);

var _cpx = require("cpx");

var _cpx2 = _interopRequireDefault(_cpx);

var _fs = require("fs");

var _server = require("react-dom/server");

var _rimraf = require("rimraf");

var _rimraf2 = _interopRequireDefault(_rimraf);

var _mkdirp = require("mkdirp");

var _mkdirp2 = _interopRequireDefault(_mkdirp);

var _apolloClient = require("apollo-client");

var _nodeFetch = require("node-fetch");

var _nodeFetch2 = _interopRequireDefault(_nodeFetch);

var _apolloLinkHttp = require("apollo-link-http");

var _apolloCacheInmemory = require("apollo-cache-inmemory");

var _graphqlTag = require("graphql-tag");

var _graphqlTag2 = _interopRequireDefault(_graphqlTag);

var _jss = require("react-jss/lib/jss");

var _jss2 = require("jss");

var _jssPresetDefault = require("jss-preset-default");

var _jssPresetDefault2 = _interopRequireDefault(_jssPresetDefault);

var _JssProvider = require("react-jss/lib/JssProvider");

var _JssProvider2 = _interopRequireDefault(_JssProvider);

var _createGenerateClassName = require("material-ui/styles/createGenerateClassName");

var _createGenerateClassName2 = _interopRequireDefault(_createGenerateClassName);

var _styledComponents = require("styled-components");

var _Header = require("./components/Header");

var _Header2 = _interopRequireDefault(_Header);

var _Provider = require("./components/Provider");

var _Provider2 = _interopRequireDefault(_Provider);

var _Page = require("./components/Page");

var _Page2 = _interopRequireDefault(_Page);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }
/* eslint-disable import/no-unresolved,import/extensions,no-underscore-dangle */


_get__("program").usage("[options] <url> <output>").version("0.1.0").parse(process.argv);

var outputDir = process.argv[3] || "graphql-ui-reports";
var endpoint = process.argv[2] || "http://localhost:8080/graphql";

var client = new (_get__("ApolloClient"))({
  link: new (_get__("HttpLink"))({ uri: _get__("endpoint"), fetch: _get__("fetch") }),
  cache: new (_get__("InMemoryCache"))()
});

var output = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var response, sheet, jss, sheetsRegistry, reportFileContent, styleTags, css;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return _get__("client").query({
              query: _get__("gql")(_templateObject)
            });

          case 2:
            response = _context.sent;
            sheet = new (_get__("ServerStyleSheet"))();
            jss = _get__("create")(_get__("preset")());


            jss.options.createGenerateClassName = _get__("createGenerateClassName");

            sheetsRegistry = new (_get__("SheetsRegistry"))();
            _context.next = 9;
            return _get__("renderToString")(_get__("React").createElement(
              _get__("StyleSheetManager"),
              { sheet: sheet.instance },
              _get__("React").createElement(
                _get__("JssProvider"),
                { registry: sheetsRegistry, jss: jss },
                _get__("React").createElement(
                  _get__("Provider"),
                  null,
                  _get__("React").createElement(
                    "div",
                    null,
                    _get__("React").createElement(
                      _get__("Header"),
                      null,
                      _get__("React").createElement(
                        "div",
                        null,
                        _get__("React").createElement(_get__("Page"), {
                          endpoint: _get__("endpoint"),
                          queries: response.data.__schema.queryType ? response.data.__schema.queryType.fields || [] : [],
                          mutations: response.data.__schema.mutationType ? response.data.__schema.mutationType.fields || [] : []
                        })
                      )
                    )
                  )
                )
              )
            ));

          case 9:
            reportFileContent = _context.sent;
            styleTags = sheet.getStyleTags();
            css = sheetsRegistry.toString();
            _context.next = 14;
            return _get__("writeFileSync")(_get__("outputDir") + "/index.html", "<!DOCTYPE html>\n<style>" + css + "</style>" + styleTags + reportFileContent, { encoding: "utf8" });

          case 14:
            _context.next = 16;
            return _get__("cpx").copySync(__dirname + "/../static/actions.js", "" + _get__("outputDir"));

          case 16:
            _context.next = 18;
            return _get__("cpx").copySync(__dirname + "/../static/favicon.ico", "" + _get__("outputDir"));

          case 18:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function output() {
    return _ref.apply(this, arguments);
  };
}();

var start = function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return _get__("rimraf").sync(_get__("outputDir"));

          case 2:
            _context2.next = 4;
            return _get__("mkdirp").sync(_get__("outputDir"));

          case 4:
            _context2.next = 6;
            return _get__("output")();

          case 6:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function start() {
    return _ref2.apply(this, arguments);
  };
}();

_get__("start")(_get__("program"));

function _getGlobalObject() {
  try {
    if (!!global) {
      return global;
    }
  } catch (e) {
    try {
      if (!!window) {
        return window;
      }
    } catch (e) {
      return this;
    }
  }
}

;
var _RewireModuleId__ = null;

function _getRewireModuleId__() {
  if (_RewireModuleId__ === null) {
    var globalVariable = _getGlobalObject();

    if (!globalVariable.__$$GLOBAL_REWIRE_NEXT_MODULE_ID__) {
      globalVariable.__$$GLOBAL_REWIRE_NEXT_MODULE_ID__ = 0;
    }

    _RewireModuleId__ = __$$GLOBAL_REWIRE_NEXT_MODULE_ID__++;
  }

  return _RewireModuleId__;
}

function _getRewireRegistry__() {
  var theGlobalVariable = _getGlobalObject();

  if (!theGlobalVariable.__$$GLOBAL_REWIRE_REGISTRY__) {
    theGlobalVariable.__$$GLOBAL_REWIRE_REGISTRY__ = Object.create(null);
  }

  return __$$GLOBAL_REWIRE_REGISTRY__;
}

function _getRewiredData__() {
  var moduleId = _getRewireModuleId__();

  var registry = _getRewireRegistry__();

  var rewireData = registry[moduleId];

  if (!rewireData) {
    registry[moduleId] = Object.create(null);
    rewireData = registry[moduleId];
  }

  return rewireData;
}

(function registerResetAll() {
  var theGlobalVariable = _getGlobalObject();

  if (!theGlobalVariable['__rewire_reset_all__']) {
    theGlobalVariable['__rewire_reset_all__'] = function () {
      theGlobalVariable.__$$GLOBAL_REWIRE_REGISTRY__ = Object.create(null);
    };
  }
})();

var INTENTIONAL_UNDEFINED = '__INTENTIONAL_UNDEFINED__';
var _RewireAPI__ = {};

(function () {
  function addPropertyToAPIObject(name, value) {
    Object.defineProperty(_RewireAPI__, name, {
      value: value,
      enumerable: false,
      configurable: true
    });
  }

  addPropertyToAPIObject('__get__', _get__);
  addPropertyToAPIObject('__GetDependency__', _get__);
  addPropertyToAPIObject('__Rewire__', _set__);
  addPropertyToAPIObject('__set__', _set__);
  addPropertyToAPIObject('__reset__', _reset__);
  addPropertyToAPIObject('__ResetDependency__', _reset__);
  addPropertyToAPIObject('__with__', _with__);
})();

function _get__(variableName) {
  var rewireData = _getRewiredData__();

  if (rewireData[variableName] === undefined) {
    return _get_original__(variableName);
  } else {
    var value = rewireData[variableName];

    if (value === INTENTIONAL_UNDEFINED) {
      return undefined;
    } else {
      return value;
    }
  }
}

function _get_original__(variableName) {
  switch (variableName) {
    case "program":
      return _commander2.default;

    case "ApolloClient":
      return _apolloClient.ApolloClient;

    case "HttpLink":
      return _apolloLinkHttp.HttpLink;

    case "endpoint":
      return endpoint;

    case "fetch":
      return _nodeFetch2.default;

    case "InMemoryCache":
      return _apolloCacheInmemory.InMemoryCache;

    case "client":
      return client;

    case "gql":
      return _graphqlTag2.default;

    case "ServerStyleSheet":
      return _styledComponents.ServerStyleSheet;

    case "create":
      return _jss2.create;

    case "preset":
      return _jssPresetDefault2.default;

    case "createGenerateClassName":
      return _createGenerateClassName2.default;

    case "SheetsRegistry":
      return _jss.SheetsRegistry;

    case "renderToString":
      return _server.renderToString;

    case "writeFileSync":
      return _fs.writeFileSync;

    case "outputDir":
      return outputDir;

    case "cpx":
      return _cpx2.default;

    case "rimraf":
      return _rimraf2.default;

    case "mkdirp":
      return _mkdirp2.default;

    case "output":
      return output;

    case "start":
      return start;

    case "React":
      return _react2.default;

    case "StyleSheetManager":
      return _styledComponents.StyleSheetManager;

    case "JssProvider":
      return _JssProvider2.default;

    case "Provider":
      return _Provider2.default;

    case "Header":
      return _Header2.default;

    case "Page":
      return _Page2.default;
  }

  return undefined;
}

function _assign__(variableName, value) {
  var rewireData = _getRewiredData__();

  if (rewireData[variableName] === undefined) {
    return _set_original__(variableName, value);
  } else {
    return rewireData[variableName] = value;
  }
}

function _set_original__(variableName, _value) {
  switch (variableName) {}

  return undefined;
}

function _update_operation__(operation, variableName, prefix) {
  var oldValue = _get__(variableName);

  var newValue = operation === '++' ? oldValue + 1 : oldValue - 1;

  _assign__(variableName, newValue);

  return prefix ? newValue : oldValue;
}

function _set__(variableName, value) {
  var rewireData = _getRewiredData__();

  if ((typeof variableName === "undefined" ? "undefined" : _typeof(variableName)) === 'object') {
    Object.keys(variableName).forEach(function (name) {
      rewireData[name] = variableName[name];
    });
  } else {
    if (value === undefined) {
      rewireData[variableName] = INTENTIONAL_UNDEFINED;
    } else {
      rewireData[variableName] = value;
    }

    return function () {
      _reset__(variableName);
    };
  }
}

function _reset__(variableName) {
  var rewireData = _getRewiredData__();

  delete rewireData[variableName];

  if (Object.keys(rewireData).length == 0) {
    delete _getRewireRegistry__()[_getRewireModuleId__];
  }

  ;
}

function _with__(object) {
  var rewireData = _getRewiredData__();

  var rewiredVariableNames = Object.keys(object);
  var previousValues = {};

  function reset() {
    rewiredVariableNames.forEach(function (variableName) {
      rewireData[variableName] = previousValues[variableName];
    });
  }

  return function (callback) {
    rewiredVariableNames.forEach(function (variableName) {
      previousValues[variableName] = rewireData[variableName];
      rewireData[variableName] = object[variableName];
    });
    var result = callback();

    if (!!result && typeof result.then == 'function') {
      result.then(reset).catch(reset);
    } else {
      reset();
    }

    return result;
  };
}

exports.__get__ = _get__;
exports.__GetDependency__ = _get__;
exports.__Rewire__ = _set__;
exports.__set__ = _set__;
exports.__ResetDependency__ = _reset__;
exports.__RewireAPI__ = _RewireAPI__;
exports.default = _RewireAPI__;